Subject: Re: bug#24089: 25.1; Dired: diff error on = <RET> if the file has a backup inside .~/

From: Eli Zaretskii <[email-masked]>
Date: Sat, 06 Aug 2016 13:18:50 +0300

> From: Jorge Peixoto de Morais Neto <[email-masked]>
> Cc: [email-masked]
> Date: Tue, 02 Aug 2016 23:04:24 -0300
> 
> On Sun, 2016-07-31 at 18:08 +0300, Eli Zaretskii wrote:
> > How about the alternative patch below?  It fixes the doc string, and
> > makes the prompt be without the default in the second case.  Is that
> > good enough, in your opinion?
> 
> This new patch is better.  This is already good.  There is one more tweak that
> maybe could make it even better: with this latest patch, if the user types =
> <RET> in the backup file then Emacs says
>    Attempt to compare the file to itself

The same happens in other situations when there's no default
dired-diff can intuit.  So this behavior is not new to dired-diff.

> Wouldn't it be better if dired-diff refused the minibuffer input if it is not
> a valid file?  This way, if the user types = <RET>, Emacs will display "[no
> match]", which would be more precise.

No, I think the "[No match]" thing is worse: it leaves the user
wondering what it means.  (Match for what?)  I believe the fact that
there's no default value is a hint good enough for the user to become
aware that she must type something.

I committed the patch to the master branch, and I'm marking this bug
done.  Thanks a lot for reporting this subtle bug and for testing the
fixes.